<?php
/**
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @copyright 2005 Camptocamp SA
 * @package Tests
 * @version $Id: AllTests.php,v 1.10 2005-06-21 13:11:17 sypasche Exp $
 */

/**
 * Abstract test suite
 */
require_once 'PHPUnit2/Framework/TestSuite.php';

/**
 * All tests
 */
require_once 'client/AllTests.php';
require_once 'common/AllTests.php';
require_once 'coreplugins/AllTests.php';
require_once 'plugins/AllTests.php';
require_once 'projects/AllTests.php';
require_once 'server/AllTests.php';
require_once 'misc/AllTests.php';

/**
 * @package Tests
 * @author Yves Bolognini <yves.bolognini@camptocamp.com>
 */
class AllTests {

    /**
     * @return PHPUnit2_Framework_TestSuite
     */
    public static function suite() {

        $suite = new PHPUnit2_Framework_TestSuite;

        $suite->addTest(client_AllTests::suite());
        $suite->addTest(common_AllTests::suite());
        $suite->addTest(coreplugins_AllTests::suite());
        $suite->addTest(plugins_AllTests::suite());
        $suite->addTest(projects_AllTests::suite());
        $suite->addTest(server_AllTests::suite());
        $suite->addTest(misc_AllTests::suite());

        return $suite;
    }
}

?>
